<template>
  <v-menu open-on-hover offset-y>
    <template v-slot:activator="{ on }">
      <v-btn
        :style="
          (currentlyPath == 'Users' || currentlyPath == 'Entities' || currentlyPath == 'Roles') &&
            'background: #FFC107; border: thin solid #FFC107'
        "
        :class="isHover && `${hoverStyle}`"
        color="primary"
        outlined
        v-on="on"
      >
        Gerenciar
        <v-icon small right>mdi-wrench</v-icon>
      </v-btn>
    </template>
    <v-list>
      <v-list-item
        active-class="activeMenu"
        class="tile"
        @mouseenter="mouseEnterMenu"
        @mouseleave="isHover = false"
        v-for="(item, index) in managementItems"
        :key="index"
        :to="activeEntityUrl + item.to"
        exact
        router
      >
        <v-list-item-action class="mr-4">
          <v-icon color="primary">{{ item.icon }}</v-icon>
        </v-list-item-action>
        <v-list-item-content>
          <v-list-item-title class="primary--text" v-text="item.title" />
        </v-list-item-content>
      </v-list-item>
    </v-list>
  </v-menu>
</template>

<script>
export default {
  name: 'ManagementMenu',
  components: {},
  data: () => ({
    isHover: false,
    hoverStyle: '',
    currentlyPath: '',
    managementItems: [
      {
        title: 'Entidades',
        icon: 'mdi-notebook',
        to: '/management/entities',
      },
      {
        title: 'Papéis',
        icon: 'mdi-bookmark',
        to: '/management/roles',
      },
      {
        title: 'Usuários',
        icon: 'mdi-account-box-multiple',
        to: '/management/users',
      },
    ],
  }),
  computed: {
    activeEntityUrl() {
      return '/entity/' + this.$route.params.entityName
    },
  },
  beforeUpdate() {
    this.path()
  },
  created() {
    this.path()
  },
  methods: {
    handleEntityManagement() {
      this.$router.push(`${this.activeEntityUrl}/management`).catch((err) => {})
    },
    path() {
      let path = this.$route.name
      if (path == 'Users' || path == 'Entities' || path == 'Roles') {
        this.currentlyPath = path
      } else {
        this.currentlyPath = ''
      }
    },
    mouseEnterMenu() {
      this.isHover = true
      this.check()
    },
    check() {
      let path = this.$route.name
      if (path == 'Users' || path == 'Entities' || path == 'Roles') {
        this.hoverStyle = 'warning' //cores vuetify
      } else {
        this.hoverStyle = 'navDrive' //cores vuetify
      }
    },
  },
}
</script>
<style>
.v-list {
  padding-top: 0;
  padding-bottom: 0;
}
/* .tile:hover {
  background: #bfbfbf;
}

.activeMenu {
  background: lightgray;
} */
</style>
